# See: https://dev.twitch.tv/docs/eventsub/eventsub-subscription-types/

REQUIRED_SCOPE: dict[str, list[None | str]] = {
    'automod.message.hold': ['moderator:manage:automod'],
    'automod.message.update': ['moderator:manage:automod'],
    'automod.settings.update': ['moderator:read:automod_settings'],
    'automod.terms.update': ['moderator:manage:automod'],
    'channel.ad_break.begin': ['channel:read:ads'],
    'channel.ban': ['channel:moderate'],
    'channel.channel_points_automatic_reward_redemption.add': ['channel:read:redemptions'],
    'channel.channel_points_custom_reward.add': ['channel:read:redemptions'],
    'channel.channel_points_custom_reward.remove': ['channel:read:redemptions'],
    'channel.channel_points_custom_reward.update': ['channel:read:redemptions'],
    'channel.channel_points_custom_reward_redemption.add': ['channel:read:redemptions'],
    'channel.channel_points_custom_reward_redemption.update': ['channel:read:redemptions'],
    'channel.charity_campaign.donate': ['channel:read:charity'],
    'channel.charity_campaign.progress': ['channel:read:charity'],
    'channel.charity_campaign.start': ['channel:read:charity'],
    'channel.charity_campaign.stop': ['channel:read:charity'],
    'channel.chat.clear': ['channel:bot'],
    'channel.chat.clear_user_messages': ['channel:bot'],
    'channel.chat.message_delete': ['channel:bot'],
    'channel.chat.notification': ['channel:bot'],
    'channel.chat.user_message_hold': ['user:bot'],
    'channel.chat.user_message_update': ['user:bot'],
    'channel.chat_settings.update': ['channel:bot'],
    'channel.cheer': ['bits:read'],
    'channel.follow': ['moderator:read:followers'],
    'channel.goal.begin': ['channel:read:goals'],
    'channel.goal.end': ['channel:read:goals'],
    'channel.goal.progress': ['channel:read:goals'],
    'channel.guest_star_guest.update': ['channel:read:guest_star'],
    'channel.guest_star_session.begin': ['channel:read:guest_star'],
    'channel.guest_star_session.end': ['channel:read:guest_star'],
    'channel.guest_star_settings.update': ['channel:read:guest_star'],
    'channel.hype_train.begin': ['channel:read:hype_train'],
    'channel.hype_train.end': ['channel:read:hype_train'],
    'channel.hype_train.progress': ['channel:read:hype_train'],
    'channel.moderate': [
        'moderator:read:blocked_terms',
        'moderator:read:chat_settings',
        'moderator:read:unban_requests',
        'moderator:read:banned_users',
        'moderator:read:chat_messages',
        'moderator:read:moderators',
        'moderator:read:vips',
        'moderator:read:warnings',
    ],
    'channel.moderator.add': ['moderation:read'],
    'channel.moderator.remove': ['moderation:read'],
    'channel.poll.begin': ['channel:read:polls'],
    'channel.poll.end': ['channel:read:polls'],
    'channel.poll.progress': ['channel:read:polls'],
    'channel.prediction.begin': ['channel:read:predictions'],
    'channel.prediction.end': ['channel:read:predictions'],
    'channel.prediction.lock': ['channel:read:predictions'],
    'channel.prediction.progress': ['channel:read:predictions'],
    'channel.raid': ['channel.raid'],
    'channel.shared_chat.begin': [None],
    'channel.shared_chat.end': [None],
    'channel.shared_chat.update': [None],
    'channel.shield_mode.begin': ['moderator:read:shield_mode'],
    'channel.shield_mode.end': ['moderator:read:shield_mode'],
    'channel.shoutout.create': ['moderator:read:shoutouts'],
    'channel.shoutout.receive': ['moderator:read:shoutouts'],
    'channel.subscribe': ['channel:read:subscriptions'],
    'channel.subscription.end': ['channel:read:subscriptions'],
    'channel.subscription.gift': ['channel:read:subscriptions'],
    'channel.subscription.message': ['channel:read:subscriptions'],
    'channel.suspicious_user.message': [' moderator:read:suspicious_users'],
    'channel.suspicious_user.update': [' moderator:read:suspicious_users'],
    'channel.unban': ['channel:moderate'],
    'channel.unban_request.create': ['moderator:read:unban_requests'],
    'channel.unban_request.resolve': ['moderator:read:unban_requests'],
    'channel.update': [None],
    'channel.vip.add': ['channel:read:vips'],
    'channel.vip.remove': ['channel:read:vips'],
    'channel.warning.acknowledge': ['moderator:read:warnings'],
    'channel.warning.send': ['moderator:read:warnings'],
    'stream.offline': [None],
    'stream.online': [None],
    'user.update': [None],
    'user.whisper.message': ['user:read:whispers'],
}